> For the complete documentation index, see [llms.txt](https://reduxbundler.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://reduxbundler.com/api-reference/top-level.md).

# Top Level API

## `composeBundles(...bundles)`

Returns a function that will return a fully configured store composed of all the bundles **including some built-in ones that you're likely to want**. If you have any data to use as starting state, it can be passed to this function.

Included bundles:

* `appTimeBundle`
* `asyncCountBundle`
* `onlineBundle`
* `createUrlBundle()`
* `createReactorBundle()`
* `debugBundle`

## `composeBundlesRaw(...bundles)`

Same as `composeBundles(...bundles)` but does not include anything bundles by default.

## `createSelector()`

Can be used to create selectors as described in the `selectX` section of the bundle API.

## `HAS_WINDOW`

Is `window` defined

## `IS_BROWSER`

Like `HAS_WINDOW` but also tries to determine if we're in a WebWorker.

## `raf`

Shim for `requestAnimationFrame` with fallback to `setTimeout(0)` for node.

## `ric`

Shim for `requestIdleCallback` with fallback to `setTimeout(0)` for node.

## Exports `*` from redux

As previously stated, this library includes Redux, so redux methods are exported too.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://reduxbundler.com/api-reference/top-level.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
